
% before run this file, please load the all mat that in folder Iowa184
% including X,time1,time2,time3,time4,RC,pa,f3
% which is the simulation result of IA.m
% this file is corresponding to Figure 7 in the paper
% Figure 7 is the result of IApredict, IAtest1.m and IAtest2.m

n = 1001; % region size

T1=10; % period from infected to confirmed
T2=4;  % period from confirmed to hospitalized
T3=4;  % period from hospitalized to recovered


aa = 1/2;
bb = 1/(2*2^0.5);

dd = 10; % maximum moving step length L

uu = 0.11; % hospitalization fraction (u)
kk = 0.17; % dead fraction (k)

for t = 1:100
    
   % Possibility of being infected for each individual
   % correspond to Eq.(3)
    P = zeros(n,n);
    for i = 3:n-2
        for j = 3:n-2
            if X(i,j) == 0 && (X(i-1,j-1) == 3 ||  X(i-1,j) == 3 ||  X(i-1,j+1) == 3||  X(i,j-1) == 3||  X(i,j+1) == 3||  X(i+1,j-1) == 3 ||  X(i+1,j) == 3 ||  X(i+1,j+1) == 3 || X(i-1,j-1) == 8 ||  X(i-1,j) == 8 ||  X(i-1,j+1) == 8||  X(i,j-1) == 8||  X(i,j+1) == 8||  X(i+1,j-1) == 8 ||  X(i+1,j) == 8 ||  X(i+1,j+1) == 8)
                ifx1 = (X(i-1,j-1) == 3);
                ifx2 = (X(i-1,j) == 3);
                ifx3 = (X(i-1,j+1) == 3);
                ifx4 = (X(i,j-1) == 3);
                ifx5 = (X(i,j+1) == 3);
                ifx6 = (X(i+1,j-1) == 3);
                ifx7 = (X(i+1,j) == 3);
                ifx8 = (X(i+1,j+1) == 3);
                ifx11 = (X(i-1,j-1) == 8);
                ifx22 = (X(i-1,j) == 8);
                ifx33 = (X(i-1,j+1) == 8);
                ifx44 = ( X(i,j-1) == 8);
                ifx55 = (X(i,j+1) == 8);
                ifx66 = (X(i+1,j-1) == 8);
                ifx77 = (X(i+1,j) == 8);
                ifx88 = (X(i+1,j+1) == 8);
                AA = (f3(i-1,j)*(ifx2)*(1-RC(i,j)))^0.5 + (f3(i,j+1)*(ifx5)*(1-RC(i,j)))^0.5+ (f3(i+1,j)*(ifx7)*(1-RC(i,j)))^0.5+ (f3(i,j-1)*(ifx4)*(1-RC(i,j)))^0.5 + (0.5*f3(i-1,j)*(ifx22)*(1-RC(i,j)))^0.5 + (0.5*f3(i,j+1)*(ifx55)*(1-RC(i,j)))^0.5+ (0.5*f3(i+1,j)*(ifx77)*(1-RC(i,j)))^0.5+ (0.5*f3(i,j-1)*(ifx44)*(1-RC(i,j)))^0.5;
                BB = (f3(i-1,j-1)*(ifx1)*(1-RC(i,j)))^0.5 + (f3(i-1,j+1)*(ifx3)*(1-RC(i,j)))^0.5+ (f3(i+1,j-1)*(ifx6)*(1-RC(i,j)))^0.5+ (f3(i+1,j+1)*(ifx8)*(1-RC(i,j)))^0.5 + (0.5*f3(i-1,j-1)*(ifx11)*(1-RC(i,j)))^0.5 + (0.5*f3(i-1,j+1)*(ifx33)*(1-RC(i,j)))^0.5+ (0.5*f3(i+1,j-1)*(ifx66)*(1-RC(i,j)))^0.5+ (0.5*f3(i+1,j+1)*(ifx88)*(1-RC(i,j)))^0.5;
                P(i,j) = AA *aa /4 + BB *bb /4 ;
            end
        end
    end
    
     %The states of one individual in the cells are updated by following:
    for i = 3:n-2
        for j = 3:n-2
            if X(i,j) == 0 && P(i,j) > rand(1,1) && pa(i,j) > rand(1,1)
                X(i,j) = 8;
            else if X(i,j) == 0 && P(i,j) > rand(1,1) && pa(i,j) <= rand(1,1)
                    X(i,j) = 3;
                end
            end
        end
    end
    
    for i = 3:n-2
        for j = 3:n-2
            if X(i,j) == 8
                time4(i,j) = time4(i,j) +1;
            end
        end
    end
    
    for i = 3:n-2
        for j = 3:n-2
            if time4(i,j) == T1 + T2
                X(i,j) = 5;
                time4(i,j) = 0;
            end
        end
    end
    
    for i = 3:n-2
        for j = 3:n-2
            if X(i,j) == 3
                time1(i,j) = time1(i,j) +1;
            end
        end
    end
    
    isC = sum(sum(time1 == T1));   % daily confirmed in simulation
    
    for i = 3:n-2
        for j = 3:n-2
            
            if time1(i,j) == T1
                X(i,j) = 4;
                time1(i,j) = 0;
            end
            
            if X(i,j) == 4
                time2(i,j) = time2(i,j) + 1;
            end
        end
    end
    
    isH = round(uu * sum(sum(time2 == T2)));   % daily hospitalized in simulation

    for i = 3:n-2
        for j = 3:n-2
            if time2(i,j) == T2
                if rand(1,1) > uu
                    X(i,j) = 5;
                    time2(i,j) = 0;
                else X(i,j) = 6;
                    time2(i,j) = 0;
                end
            end
            
            if X(i,j) == 6
                time3(i,j) =time3(i,j) + 1;
            end
        end
    end

    
    isD = round(kk * sum(sum(time3 == T3)));   % daily dead in simulation
    
    for i = 3:n-2
        for j = 3:n-2
            if time3(i,j) == T3
                if rand(1,1) > kk
                    X(i,j) = 5;
                    time3(i,j) = 0;
                else X(i,j) = 7;
                    time3(i,j) = 0;
                end
            end
        end
    end
       
  % moving proportion m=0.16
   mov = 0.16;
   m = zeros(n,n);
   ss = 0; 
   for i = 13:n-12
        for j = 13:n-12
            m(i,j) = rand(1,1);
            if m(i,j) > 1-mov     
                ss = ss + 1;
            end
        end
   end
            
    rr1 = zeros(n,n); % record X 
    rr2 = zeros(n,n); % record f3 
    rr3 = zeros(n,n); % record ¼RC 
    rr4 = zeros(n,n); % record pa 


    d1 = zeros(n,n);
    d2 = zeros(n,n);
    
    % realize the movement (m=0.16,d=10),0.16 of the cell move within 10
    for i = 13:n-12
        for j = 13:n-12
            if m(i,j) > 1-mov
                d1(i,j) = randperm(dd,1) -randperm(dd,1);
                d2(i,j) = randperm(dd,1) -randperm(dd,1);
                
                rr1(i,j) = X(i,j);
                X(i,j) = X(i+d1(i,j),j+d2(i,j));
                X(i+d1(i,j),j+d2(i,j)) = rr1(i,j);
                
                rr2(i,j) = f3(i,j);
                f3(i,j) = f3(i+d1(i,j),j+d2(i,j));
                f3(i+d1(i,j),j+d2(i,j)) = rr2(i,j);
                
                rr3(i,j) = RC(i,j);
                RC(i,j) = RC(i+d1(i,j),j+d2(i,j));
                RC(i+d1(i,j),j+d2(i,j)) = rr3(i,j);
                
                rr4(i,j) = pa(i,j);
                pa(i,j) = pa(i+d1(i,j),j+d2(i,j));
                pa(i+d1(i,j),j+d2(i,j)) = rr4(i,j);
                
            end
        end
    end
    
     % self-isolationS  Si
    for i = 3:n-2
        for j = 3:n-2
            if X(i,j) == 2
               X(i,j) = 0;
            end
        end
    end
    
    qq = zeros(n,n);
    % self-isolation proportion q = 0.4
    q = 0.4;
    if t >= 1
        for i = 3:n-2
            for j = 3:n-2
                qq(i,j) = rand(1,1);
                if qq(i,j) > 0 && qq(i,j) <= q && X(i,j) ==0
                    X(i,j) = 2;
                end
            end
        end
    end
    

    % test strategy 2
    tes = zeros(n,n);
    for i = 3:n-2
            for j = 3:n-2
                tes(i,j)=rand(1,1);
            end
    end
    
    %interval of 30 days, 90 percent of individuals are tested.
    if  t == 30  ||  t == 60    ||   t == 90     
        for i = 3:n-2
            for j = 3:n-2
                if X(i,j) == 3  || X(i,j) == 8
                    if rand(1,1) <= 0.9
                    X(i,j) = 4;
                    time1(i,j) = 0;
                    time4(i,j) = 0;
                    end
                end
            end
        end
    end
    
isI = sum(sum(X==3))-1;   % current infected (symptomatic) number in simulation
isIa = sum(sum(X==8))-1;  % current infected (asymptomatic) number in simulation
isR = sum(sum(X==5))-1;   % culmulative recovered number in simulation

W(t,:) = [isC(:) isH(:) isD(:) isI(:) isIa(:) isR(:)  isI(:)+isIa(:)];

end

%draw the figures (Figure 7 in the paper)
figure(2)
plot(1:100,W(:,1),'r','LineWidth',3) 
xlabel('number of days','Fontname', 'Times New Roman','fontsize',16);
ylabel('number of confirmed people','Fontname', 'Times New Roman','fontsize',16);
legend('daily confirmed in simulation')
set(legend,'Fontname','Times New Roman','FontSize',16)


figure(3)
plot(1:100,W(:,7),'k','LineWidth',3) 
hold on 
plot(1:100,W(:,5),'m','LineWidth',3) 
hold on 
plot(1:100,W(:,6),'g','LineWidth',3) 
xlabel('number of days','Fontname', 'Times New Roman','fontsize',16);
ylabel('population','Fontname', 'Times New Roman','fontsize',16);
legend('current infected','asymptomatic infected','cumulative recovered')
set(legend,'Fontname','Times New Roman','FontSize',16)