
% before run this file, please load the AC.mat and AC2.mat first, 
% AC.mat is the actucal data of New York City in terms of daily confirmed,hospitalized and dead number (7 day moving average)
% AC2.mat is the actucal data of Iowa in terms of daily confirmed,hospitalized and dead number (7 day moving average)
% AC.mat and AC2.mat are both ranged from March 6 to August 31
% this file is corresponding to Figure 5 in the paper

% q for NYC
qn = zeros(1,178);
for t = 39:199
    qn(t-21) = 0.7 - 0.1*(AC(t-20,1)-AC(t-21,1))/AC(t-21,1)/0.025;
    if  qn(t-21) > 1
        qn(t-21) = 1;
    end
    if qn(t-21) < 0
       qn(t-21) = 0;
    end
end
plot(1:178,qn(1,1:178),'b','LineWidth',1) 
hold on

% q for Iowa
qi = zeros(1,178);
for t = 59:184
    qi(t-6) = 0.7 - 0.1*(AC2(t-5,1)-AC2(t-6,1))/AC2(t-6,1)/0.025;
    if  qi(t-6) > 1
        qi(t-6) = 1;
    end
    if qi(t-6) < 0
       qi(t-6) = 0;
    end
end
plot(1:178,qi(1,1:178),'r','LineWidth',1) 

xlabel('number of days','Fontname', 'Times New Roman','fontsize',16);
ylabel('self-isolation proportion (q)','Fontname', 'Times New Roman','fontsize',16);
legend('q for NYC','q for IA')
set(legend,'Fontname','Times New Roman','FontSize',16)
ylim([-0.2,1.2])


